import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MyWorld here.
 * 
 * Catherine McKenna
 * Cailin Nally
 * Matt Wan
 * 4/23/18
 */
public class Level1 extends World
{
    private int score;
    public int hunger; 
    private int food;

    /**
     * Constructor for objects of class MyWorld.
     * 
     */
    public Level1()
    {    
        super(1000, 800, 1); 
        Dolphin dolphin = new Dolphin();

        score = 0;
        hunger = 2000;

        showHunger();

        addObject(dolphin, 133, 658);
        setPaintOrder(Dolphin.class);
        setPaintOrder(Wall.class);
        prepare();
        
        //act();//Ms. McGee: don't call the act method.
        showScore(); //I put the showScore in the constructor because we need to see it before the game begins
    }

    public void act()
    {

        if (Greenfoot.getRandomNumber (100) ==1)
        {
            addObject(new Shark(), 1000, Greenfoot.getRandomNumber(800));
        }
        if (Greenfoot.getRandomNumber (100) ==1)
        {
            addObject(new SchoolFish1(), 1, Greenfoot.getRandomNumber(800));
        }
        if (Greenfoot.getRandomNumber (100) ==1)
        {
            addObject(new SchoolFish2(), 1000, Greenfoot.getRandomNumber(800));
        }
        if (Greenfoot.getRandomNumber (100) <3)
        {
            addObject(new GrayFish(), 1000, Greenfoot.getRandomNumber(800));
        }
        if (Greenfoot.getRandomNumber (100) <1)
        {
            addObject(new Goldfish(), 1000, Greenfoot.getRandomNumber(800));
        }
        countHunger();
    }

    public void addScore(int points)
    {
        score = score + points;
        showScore();
        if (score < 0) 
        {
            Greenfoot.playSound("splash.wav");
            Greenfoot.stop();
        }
    }

    public void addHunger(int food)
    {
        hunger = hunger + food;
        showHunger();
        if (hunger < 0) 
        {
            Greenfoot.playSound("game-over.wav");
            Greenfoot.stop();
        }
        if (Greenfoot.getRandomNumber (100) <3)
        {
            addObject(new GrayFish(), 1000, Greenfoot.getRandomNumber(800));
        }
    }

    private void showScore()
    {
        showText("Score: " + score, 120,20);
        getBackground().fillRect(50,10,120,20); //I was unable to see the score with a background color  
    }

    /**
     * Prepare the world for the start of the program.
     * That is: create the initial objects and add them to the world.
     */
    private void prepare()
    {

        Rock rock = new Rock();
        addObject(rock,610,728);
        Rock rock2 = new Rock();
        addObject(rock2,304,796);

        Wall wall = new Wall();
        addObject(wall,0,400);

        Wall wall2 = new Wall();
        addObject(wall2,1000,400);

        Seaweed seaweed = new Seaweed();
        addObject(seaweed,467,657);
    }

    public void countHunger()
    {
        hunger--;
        showHunger();
        if (hunger==0)
        {
            showEndMessage();
            Greenfoot.stop();
        }
    }

    private void showHunger()
    {
        showText ("Hunger:"+ hunger, 100, 100);
        //getBackground().fillRect(90,90,100,100);   
    }

    private void showEndMessage()
    {
        showText ("The shows's over. Your score is :"+score, 390, 180);
    }
}
